+               ** FILE INPUT/OUTPUT STATEMENTS ROUTINES **
.             ===============================================
.
.                      Input/Output Section for File:
.
.                  CMT -- Comments about payments
.                 --------------------------------------------
.
.  This 'INCLUDE' module contains all routines required to perform I/O
.  with the CMT data file. These routines are normally the only ones to
.  be used when accessing this data file.
.
.
.   Created by SYSTEMAKER ver. 2.10     on 02/14/03 at 15:40
.
.   (Code is tailored for the Sunbelt  P L / B  compiler)
.
.
. *------------*            DATABASE MANAGEMENT SYSTEM
. | SYSTEMAKER |         APPLICATION SOURCE CODE GENERATOR
. *------------*      INFOPRO, Inc. Aurora, IL 60504 (USA)
.
.                      +-----------------------------------+
.                      |           Infopro, Inc.           |
.   License no.: 9999  |       2625 Butterfield Road       |
.    & Site no.: 9999  |        Oak Brook, IL  USA         |
.                      |    ** IN-HOUSE DEVELOPMENT **     |
.                      +-----------------------------------+
.
         %IFNDEF   IO$CMTIO            . allow multiple including
IO$CMTIO EQU       1                   . I/O module has been included
 
         %IFNDEF   CMT$OPNX            . VAR module not here yet?
         INCLUDE   DEMOCMT/VAR         .    include it now
         %ENDIF
         if (0)                        . allow including at top of program
+
.  Key building routines for: CMT -- Comments about payments
.  ---------------------------------------------------------------------
.
*
         %IFZ      $EDITCMT
         %IFNZ     IO$CMT
CMT$KEYX
CMT$KEY  MOVE      CMTCMTNO,CMT$KEY    . Comment number
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$CMT
         %ENDIF                        . closing $EDITCMT
*
.  Routine to clear all record image variables. Exit: OVER flag is set.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCMT
IONLCMT  UNPACK    NULL, CMT$MLST      . Blank/Clear/Zero all vars
         MOVE      "10",N1             . Set 'OVER' flag showing read failed
         RETURN                        . Exit with OVER flag giving result
         %ENDIF                        . closing $EDITCMT
+
.  Open routines for file: CMT -- Comments about payments
.  ------------------------------------------------------------------
.
*
.  Open all related indices to the file
.  ------------------------------------
.
IOPNCMTX MOVE      ZERO,IOFLAG         . clear the I/O error flag
         BRANCH    CMT$OPNX,RETURN     . do nothing if all indexes now open
         %IFNZ     IO$CMT
         CALL      IOPNCMT             . Primary key "by assigned number#
         BRANCH    IOFLAG,IOPRCMT      .
         %ENDIF                        . closing IO$CMT
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTA
         CALL      IOPNCMTA            . General free-form lookup
         BRANCH    IOFLAG,IOPRCMT      .
         %ENDIF                        . closing IO$CMTA
         %ENDIF                        . closing $EDITCMT
         MOVE      ONE,CMT$OPNX        . indicate all indexes now open
IOPRCMT  RETURN                        .
*
.  Open (index) file: CMT -- Primary key "by assigned number#
.  --------------------------------------------------------------
.
         %IFNZ     IO$CMT
IOPNCMT  MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    CMT$OPN,IOPXCMT     . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      CMT$FNM,$BLDFNMN    . build this file name
         MOVE      "CMT",  $BLDFNMF    . for file code: 'CMT'
         MOVE      NULL,   $BLDFNMI    . and index code: ' '
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,CMT$FNM    . set local name variable
         MOVE      CMT$FNM,FILENAME    . set file name for error msg
         BRANCH    CMT$OPNM,IOP1CMT,IOP2CMT,IOP3CMT
.                           shared     read   exclusive
IOP1CMT  OPEN      CMT,$BLDFNMX
         GOTO      IOP0CMT             .
IOP2CMT  OPEN      CMT,$BLDFNMX,READ
         GOTO      IOP0CMT             .
IOP3CMT  OPEN      CMT,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0CMT             .
IOP0CMT  BRANCH    IOFLAG,IOPXCMT      . was it found ?
         MOVE      ONE,CMT$OPN         . the CMT index is now open
IOPXCMT  RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$CMT
*
.  Open (index) file: CMTA -- General free-form lookup
.  --------------------------------------------------------------
.
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTA
IOPNCMTA MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    CMT$OPNA,IOPXCMTA   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      CMT$FNMA,$BLDFNMN   . build this file name
         MOVE      "CMT",   $BLDFNMF   . for file code: 'CMT'
         MOVE      "A",     $BLDFNMI   . and index code: 'A'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,CMT$FNMA   . set local name variable
         MOVE      CMT$FNMA,FILENAME   . set file name for error msg
         BRANCH    CMT$OPNM,IOP1CMTA,IOP2CMTA,IOP3CMTA
.                           shared     read   exclusive
IOP1CMTA OPEN      CMTA,$BLDFNMX
         GOTO      IOP0CMTA            .
IOP2CMTA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      CMTA,$BLDFNMX,READ
         %ELSE
         OPEN      CMTA,$BLDFNMX,,READ
         %ENDIF
         GOTO      IOP0CMTA            .
IOP3CMTA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      CMTA,$BLDFNMX,EXCLUSIVE
         %ELSE
         OPEN      CMTA,$BLDFNMX,,EXCLUSIVE
         %ENDIF
         GOTO      IOP0CMTA            .
IOP0CMTA BRANCH    IOFLAG,IOPXCMTA     . was it found ?
         MOVE      ONE,CMT$OPNA        . the CMTA index is now open
IOPXCMTA RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$CMTA
         %ENDIF                        . closing $EDITCMT
+
.  Read routines for index: ' ' -- Primary key "by assigned number#
.  --------------------------------------------------------------------
.
         %IFNZ     IO$CMT
IORKCMT  BRANCH    CMT$OPN,IOX1CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX1CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITCMT
IOK$CMT  READ      CMT,CMT$KEY; CMT$RLST . random access read
         GOTO      IORXCMT             . perform post-read processing
         %ELSE
.
         READ      CMT,CMT$KEY;;       . no description field to read
         CLEAR     WSD                 . make sure desc fld buffer empty
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
*
         %IFZ      $EDITCMT
IOTKCMT  BRANCH    CMT$OPN,IOX2CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX2CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      CMT,WS;;
         RETURN                        .
         %ENDIF
*
         %ENDIF                        . closing IO$CMT
 
IOEKCMT
         MOVE      BLANKS,WSD          . no description field defined
         RETURN                        .
*
         %IFNZ     IO$CMT
IOKSCMT  BRANCH    CMT$OPN,IOX4CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX4CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCMT
IOQ$CMT  READKS    CMT; CMT$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   CMT$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCMT             . perform post-read processing
         %ELSE
.
         READKS    CMT;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
*
IOKPCMT  BRANCH    CMT$OPN,IOX3CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX3CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCMT
IOP$CMT  READKP    CMT; CMT$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   CMT$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCMT             . perform post-read processing
         %ELSE
.
         READKP    CMT;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
.
IOESCMT
         %IFZ      $EDITCMT
         PACK      $KEYTEMP,FLDTYP,CMT$KEY  . save param values
         CALL      CMT$KEY             . build correctly formatted key
         MOVE      CMT$KEY,WS          . deliver key result in WS
         MOVE      CMT$KEY,CMT$SVK     . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,CMT$KEY  . restore param values
         %ELSE
         SETLPTR   WS,6                . adjust to size of index key
         CLEAR     WSD                 . no description field defined
         %ENDIF                        . closing $EDITCMT
         GOTO      IOEKCMT             . complete the description field
*
         %IFZ      $EDITCMT
IOSQCMT  MOVE      SEQ,$RECORD         . set up for physical seq'l read
IORRCMT  BRANCH    CMT$OPN,IOX5CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX5CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READSQ",IOMODE     .  and the I/O procedure
.
         READ      CMT,$RECORD; CMT$RLST . random or seq'l read
         GOTO      IORXCMT             . perform post-read processing
         %ENDIF                        . closing $EDITCMT
*
         %IFZ      $EDITCMT
IOFRCMT  BRANCH    CMT$OPN,IOX6CMT     . is this index now open ?
         CALL      IOPNCMT             . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX6CMT  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "RPOSIT",IOMODE     .  and the I/O procedure
.
         REPOSIT   CMT,N9              . re-set the file cursor
         RETURN                        .
.
IOFPCMT  FPOSIT    CMT,N9              . get present file cursor
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
 
*
IOGZCMT  IF        (CMT$OPN = 0)       . is this index now open?
           CALL    IOPNCMT             . no... then open it now
           BRANCH  IOFLAG,IOPRCMT      . was index opened OK ?
         ENDIF
         READ      CMT,SEQ3;;          . get total file size
IOGPCMT  FPOSIT    CMT,$FILPOSN        . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$CMT
+
.  Read routines for index: 'A' -- General free-form lookup
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTA
IORKCMTA BRANCH    CMT$OPNA,IOX1CMTA   . is this index now open ?
         CALL      IOPNCMTA            . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX1CMTA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNMA,FILENAME   . set the disk file name
         MOVE      "AMREAD",IOMODE     .  and the I/O procedure
.
IOK$CMTA READ      CMTA,$AIMKLST; CMT$RLST . this is an AIM read
         GOTO      IORXCMT             . perform post-read processing
*
IOKSCMTA BRANCH    CMT$OPNA,IOX4CMTA   . is this index now open ?
         CALL      IOPNCMTA            . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX4CMTA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNMA,FILENAME   . set the disk file name
         MOVE      "READKG",IOMODE     .  and the I/O procedure
.
IOQ$CMTA READKG    CMTA; CMT$RLST      . for next generic key
         GOTO      IORXCMT             . perform post-read processing
*
         %IFNZ     C$READGP
IOKPCMTA BRANCH    CMT$OPNA,IOX3CMTA   . is this index now open ?
         CALL      IOPNCMTA            . no... then open it now
         BRANCH    IOFLAG,IOPRCMT      . was index opened OK ?
IOX3CMTA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNMA,FILENAME   . set the disk file name
         MOVE      "RDKGP ",IOMODE     .  and the I/O procedure
.
IOP$CMTA READKGP   CMTA; CMT$RLST      . read for prior generic key
         GOTO      IORXCMT             . perform post-read processing
         %ENDIF                        . closing C$READGP
*
IOGZCMTA IF        (CMT$OPNA = 0)      . is this index now open?
           CALL    IOPNCMTA            . no... then open it now
           BRANCH  IOFLAG,IOPRCMT      . was index opened OK ?
         ENDIF
         READ      CMTA,SEQ3;;         . get total file size
IOGPCMTA FPOSIT    CMTA,$FILPOSN       . get present file position
         RETURN                        .
         %ENDIF                        . closing IO$CMTA
         %ENDIF                        . closing $EDITCMT
*
.  Post processing to be performed following all full-record reads.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCMT
IORXCMT  BRANCH    IOFLAG,IOPRCMT      . exit now if I/O problem
         RETURN    IF OVER             . return with 'OVER' set
.
         MOVE      ZERO,N1             . clear the 'OVER' flag
         RETURN                        . return with 'OVER' clear
         %ENDIF                        . closing $EDITCMT
+
.  Write routine for file: CMT -- Comments about payments
.  ------------------------------------------------------------------
.
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTWT
IOWUCMT
         CALL      IOPNCMTX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      CMTCOLIS,C2         . prepare to increment counter
         CALL      $COUNTER            . for the updated record
         MOVE      C2,CMTCOLIS         .
         GOTO      IOWVCMT8            .
.
IOWTCMT
         CALL      IOPNCMTX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      $NWCOLIS,CMTCOLIS   . initialize the update counter
.
         CALL      IOLVCMT             . get new LVA value and set FILEPI
         BRANCH    IOFLAG,RETURN       . respond to error during LVA read
         RETURN    IF OVER             . no LVA value could be obtained
         CALL      CMT$KEYX            . build all record keys for WRITE
         GOTO      IOWVCMT9            . proceed to WRITE with FILEPI active
.
.   Write this record with pre-existing record key value(s)
.
IOWVCMT8
         CALL      CMT$KEYX            . build all record keys for WRITE
         IF (CMT$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CMT              .   yes, enqueue the data file
         ENDIF
.>IOZ1CMT
.
IOWVCMT9
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "WRITE",IOMODE      .  and the I/O procedure
         WRITE     CMT$FLST; CMT$WLST  . This is an indexed write to filelist
         BRANCH    IOFLAG,IOWDCMT      . respond to error during write
.
         FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful write
*
.  Come here to back the record out of the file if an error occurred
.  -----------------------------------------------------------------
.
IOWDCMT  FILEPI    0                   . release data file enqueue
         RETURN                        . exit with record NOT written
         %ENDIF                        . closing IO$CMTWT
*
.   Determine new LVA key value for write or update
.
.   ENTRY:
.      Record contents are filled for write or update
.   EXIT:
.      IOFLAG =1 if error     (the LVA key will be changed, not restored)
.      OVER is ON if no more sequence values are available
.      OVER is OFF and LVA field contains good value if all is OK
.
         %IFNZ     IO$CMTWT,IO$CMTUP   . compile for either update or write
IOLVCMT
         MOVE      CMT$KEY,$KEYTEMP    . save current value of key for update
         MOVE      CMT$LVMX,CMTCMTNO   . begin probe at max key value
         CALL      CMT$KEY             . build the key controlling this LVA
.
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "READLV",IOMODE     .  and the I/O procedure
         IF (CMT$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CMT              .   yes, enqueue the data file
         ENDIF
.>IOZ4CMT
.
.   Determine the new LVA record key
.
         READ      CMT,CMT$KEY;;       . position past last record in series
         BRANCH    IOFLAG, IOLVCMTV
         GOTO      IOLVCMTV IF NOT OVER  ...ERROR: max key is already in file
         READKP    CMT; *3,  CMTCMTNO; . record has the last-used value
         BRANCH    IOFLAG, IOLVCMTV
         GOTO      IOLVCMT6 IF OVER    . no record; start a new sequence
         COMPARE   CMT$LVFR,CMTCMTNO   . if prior value less than LVA range,
         GOTO      IOLVCMT6 IF LESS    .   then start the new sequence
.
         ADD       CMT$LVIN,CMTCMTNO   . continue existing number sequence
         GOTO      IOLVCMTV IF OVER    .   overflow- can't get a new number
         COMPARE   CMTCMTNO,CMT$LVMX   .   if new value would exceed LVA range,
         GOTO      IOLVCMTV IF LESS    .   quit- no good new values available
         MOVE      $KEYTEMP,CMT$KEY    . restore current value of this key
         RETURN                        . OVER is off - LV field value is good
.
IOLVCMT6
         MOVE      $KEYTEMP,CMT$KEY    . restore current value of this key
         MOVE      CMT$LVFR,CMTCMTNO   . start new number sequence
         RETURN                        . OVER is off - LV field value is good
.
IOLVCMTV
         FILEPI    0                   . cannot write or update record
         MOVE      $KEYTEMP,CMT$KEY    . restore current value of this key
         SETFLAG   NOT EOS             . not showing other-user interference
         SETFLAG   OVER                . signal no sequence value available
         RETURN                        . ready to exit from IO module
         %ENDIF                        . closing (IO$CMTWT,IO$CMTUP)
         %ENDIF                        . closing $EDITCMT
 
+
.  Delete routine for file: CMT -- Comments about payments
.  -------------------------------------------------------------------
.
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTDE
IODLCMT  CALL      IOPNCMTX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "DLREAD",IOMODE     .  and the I/O procedure
.
         IF (CMT$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CMT              .   yes, enqueue the data file
         ENDIF
.>IOZ2CMT
         READ      CMT,CMT$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IODXCMT      . treat I/O error as missing key
         GOTO      IODXCMT IF OVER     . did the record disappear ?
         MATCH     $RDCOLIS,CMTCOLIS   . has it changed ?
         GOTO      IODCCMT IF NOT EQUAL . yes...
         MOVE      ZERO,N1             . no missing keys yet
         MOVE      "DELETE",IOMODE     . remaining I/O will be delete
.
         DELETE    CMT$FLST            . delete record and keys using filelist
         IF OVER
           MOVE    ONE,N1              . record key not found
         ENDIF                         . if I/O trap, just proceed with IOFLAG
         FILEPI    0                   . release data file enqueue
.
         BRANCH    N1,IODXCMT          . report the missing key(s)
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit after successful delete
*
.  Come here if at least one key to be deleted was not found
.  ---------------------------------------------------------
.
IODXCMT  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with partial or no delete
*
.  Come here if foreign update was detected during delete request
.  --------------------------------------------------------------
.
IODCCMT  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no delete performed
         %ENDIF                        . closing IO$CMTDE
         %ENDIF                        . closing $EDITCMT
 
+
.  Update routine for file: CMT -- Comments about payments
.  -------------------------------------------------------------------
.
         %IFZ      $EDITCMT
         %IFNZ     IO$CMTUP
IOUPCMT
         CALL      IOPNCMTX            . open all indexes
         BRANCH    IOFLAG,IOPRCMT      . opened OK ?
.>IOX9CMT
.
         IF (CMT$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CMT              .   yes, enqueue the data file
         ENDIF
.>IOZ3CMT
.
         MOVE      CMTCOLIS,C2         . assume update will succeed, and
         CALL      $COUNTER            . increment the counter character
.
         MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CMT$FNM,FILENAME    . set the disk file name
         MOVE      "UPREAD",IOMODE     .  and the I/O procedure
         READ      CMT,CMT$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IOUXCMT      . treat I/O error as missing key
         GOTO      IOUXCMT IF OVER     . has the record disappeared ?
         MATCH     CMTCOLIS,$RDCOLIS   . has the counter changed ?
         GOTO      IOUCCMT IF NOT EQUAL . yes...
         MOVE      C2,CMTCOLIS         . increment the record counter
         MOVE      "UPDATE",IOMODE     .
         UPDATE    CMT$FLST; CMT$WLST  . update record in place by filelist
         FILEPI    0                   . release data file enqueue
 
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful update
*
.  Come here if foreign update was detected during field changes
.  -------------------------------------------------------------
.
IOUCCMT  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no update performed
*
.  Come here if I/O error, or record disappeared during field changes
.  ------------------------------------------------------------------
.
IOUXCMT  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with error or lost record
         %ENDIF                        . closing IO$CMTUP
         %ENDIF                        . closing $EDITCMT
+
.  Convert special storage format:  From AIM key memory to file format
.  -------------------------------------------------------------------
.  Entry:
.     C5  = 5-char field name
.     WS2 = AIM search string to be converted
.     $AIMFLDN = aim field number
.     $AIMTYPE = user's selected match type
.  Exit:
.     WS2 = converted result ready to go into $AIMKTRN(j)
.
         %IFZ      $EDITCMT
IOXLCMT
         RETURN
         %ENDIF                        . closing $EDITCMT
+
.  Data handling for Array: TEX -- Text
.  -------------------------------------------------------------------
.
*
.  Entry points for LOAD & STORES - one complete row of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCMT
LDCMTTEX
         CALL      LDCMT040            . Text of comment
         RETURN                        .
STCMTTEX
         CALL      STCMT040            . Text of comment
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
*
.  Entry points for LOAD & STORE - individual field of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCMT
LDCMT040 LOAD      CMTTEXT,LINENO:
                   CMT04001,CMT04002,CMT04003,CMT04004,CMT04005:
                   CMT04006,CMT04007,CMT04008,CMT04009,CMT04010:
                   CMT04011,CMT04012,CMT04013,CMT04014,CMT04015
         RETURN                        .
STCMT040 STORE     CMTTEXT,LINENO:
                   CMT04001,CMT04002,CMT04003,CMT04004,CMT04005:
                   CMT04006,CMT04007,CMT04008,CMT04009,CMT04010:
                   CMT04011,CMT04012,CMT04013,CMT04014,CMT04015
         RETURN                        .
         %ENDIF                        . closing $EDITCMT
.
.   The following label is referenced by the file maintenance program solely
.   to verify that this .IO module will update isam and aim keys if changed
.   (feature new in version 2.9.1).  When a new F.M.P. tries to include an
.   older .IO module, this label will be undefined and will prevent compilation
.   because that is not supported. Upon seeing this label undefined, the
.   programmer should regenerate the file's .IO module.
.
IOVRCMT_please_Regen  RETURN           . (never really executed)
.
         endif     . closing if (0) - allows including at top of program
         %ENDIF    . closing IO$CMTIO - allow multiple including
.
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.*               END OF I/O ROUTINE SOURCE CODE - DEMOCMT.IO
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 
