+               ** FILE INPUT/OUTPUT STATEMENTS ROUTINES **
.             ===============================================
.
.                      Input/Output Section for File:
.
.                  INV -- Invoice Master
.                 --------------------------------------------
.
.  This 'INCLUDE' module contains all routines required to perform I/O
.  with the INV data file. These routines are normally the only ones to
.  be used when accessing this data file.
.
.
.   Created by SYSTEMAKER ver. 2.10     on 02/14/03 at 15:37
.
.   (Code is tailored for the Sunbelt  P L / B  compiler)
.
.
. *------------*            DATABASE MANAGEMENT SYSTEM
. | SYSTEMAKER |         APPLICATION SOURCE CODE GENERATOR
. *------------*      INFOPRO, Inc. Aurora, IL 60504 (USA)
.
.                      +-----------------------------------+
.                      |           Infopro, Inc.           |
.   License no.: 9999  |       2625 Butterfield Road       |
.    & Site no.: 9999  |        Oak Brook, IL  USA         |
.                      |    ** IN-HOUSE DEVELOPMENT **     |
.                      +-----------------------------------+
.
         %IFNDEF   IO$INVIO            . allow multiple including
IO$INVIO EQU       1                   . I/O module has been included
 
         %IFNDEF   INV$OPNX            . VAR module not here yet?
         INCLUDE   DEMOINV/VAR         .    include it now
         %ENDIF
         if (0)                        . allow including at top of program
+
.  Key building routines for: INV -- Invoice Master
.  ---------------------------------------------------------------------
.
*
         %IFZ      $EDITINV
         %IFNZ     IO$INV
INV$KEY  MOVE      INVINVNO,INV$KEY    . Invoice Number
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$INV
         %ENDIF                        . closing $EDITINV
*
         %IFZ      $EDITINV
         %IFNZ     IO$INV2
INV$KEY2 PACK      INV$KEY2,INVCUSNO:  . Customer Number:
                            INVINVNO   . Invoice Number
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$INV2
         %ENDIF                        . closing $EDITINV
*
.  Build all the keys for this record
.
         %IFZ      $EDITINV
INV$KEYX
         %IFNZ     IO$INV
         CALL      INV$KEY             . Invoice Number
         %ENDIF                        . closing IO$INV
         %IFNZ     IO$INV2
         CALL      INV$KEY2            . Customer - Invoice
         %ENDIF                        . closing IO$INV2
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
.  Routine to clear all record image variables. Exit: OVER flag is set.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITINV
IONLINV  UNPACK    NULL, INV$MLST      . Blank/Clear/Zero all vars
         MOVE      "10",N1             . Set 'OVER' flag showing read failed
         RETURN                        . Exit with OVER flag giving result
         %ENDIF                        . closing $EDITINV
+
.  Open routines for file: INV -- Invoice Master
.  ------------------------------------------------------------------
.
*
.  Open all related indices to the file
.  ------------------------------------
.
IOPNINVX MOVE      ZERO,IOFLAG         . clear the I/O error flag
         BRANCH    INV$OPNX,RETURN     . do nothing if all indexes now open
         %IFNZ     IO$INV
         CALL      IOPNINV             . Invoice Number
         BRANCH    IOFLAG,IOPRINV      .
         %ENDIF                        . closing IO$INV
         %IFNZ     IO$INV2
         CALL      IOPNINV2            . Customer - Invoice
         BRANCH    IOFLAG,IOPRINV      .
         %ENDIF                        . closing IO$INV2
         MOVE      ONE,INV$OPNX        . indicate all indexes now open
IOPRINV  RETURN                        .
*
.  Open (index) file: INV -- Invoice Number
.  --------------------------------------------------------------
.
         %IFNZ     IO$INV
IOPNINV  MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    INV$OPN,IOPXINV     . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      INV$FNM,$BLDFNMN    . build this file name
         MOVE      "INV",  $BLDFNMF    . for file code: 'INV'
         MOVE      NULL,   $BLDFNMI    . and index code: ' '
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,INV$FNM    . set local name variable
         MOVE      INV$FNM,FILENAME    . set file name for error msg
         BRANCH    INV$OPNM,IOP1INV,IOP2INV,IOP3INV
.                           shared     read   exclusive
IOP1INV  OPEN      INV,$BLDFNMX
         GOTO      IOP0INV             .
IOP2INV  OPEN      INV,$BLDFNMX,READ
         GOTO      IOP0INV             .
IOP3INV  OPEN      INV,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0INV             .
IOP0INV  BRANCH    IOFLAG,IOPXINV      . was it found ?
         MOVE      ONE,INV$OPN         . the INV index is now open
IOPXINV  RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$INV
*
.  Open (index) file: INV2 -- Customer - Invoice
.  --------------------------------------------------------------
.
         %IFNZ     IO$INV2
IOPNINV2 MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    INV$OPN2,IOPXINV2   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      INV$FNM2,$BLDFNMN   . build this file name
         MOVE      "INV",   $BLDFNMF   . for file code: 'INV'
         MOVE      "2",     $BLDFNMI   . and index code: '2'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,INV$FNM2   . set local name variable
         MOVE      INV$FNM2,FILENAME   . set file name for error msg
         BRANCH    INV$OPNM,IOP1INV2,IOP2INV2,IOP3INV2
.                           shared     read   exclusive
IOP1INV2 OPEN      INV2,$BLDFNMX
         GOTO      IOP0INV2            .
IOP2INV2 OPEN      INV2,$BLDFNMX,READ
         GOTO      IOP0INV2            .
IOP3INV2 OPEN      INV2,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0INV2            .
IOP0INV2 BRANCH    IOFLAG,IOPXINV2     . was it found ?
         MOVE      ONE,INV$OPN2        . the INV2 index is now open
IOPXINV2 RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$INV2
+
.  Read routines for index: ' ' -- Invoice Number
.  --------------------------------------------------------------------
.
         %IFNZ     IO$INV
IORKINV  BRANCH    INV$OPN,IOX1INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX1INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITINV
IOK$INV  READ      INV,INV$KEY; INV$RLST . random access read
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READ      INV,INV$KEY;*17:    . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
         %IFZ      $EDITINV
IOTKINV  BRANCH    INV$OPN,IOX2INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX2INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      INV,WS;;
         RETURN                        .
         %ENDIF
*
         %ENDIF                        . closing IO$INV
 
IOEKINV
         %IFZ      $EDITINV
         UNPACK    INVCUSNO,WSD        . get description field contents
         %ENDIF
         TYPE      WSD                 . is this a null description?
         GOTO      IOEKINV2 IF EOS     . ...yes, make sure it's completely null
         ENDSET    WSD                 . pad with trailing blanks
IOEKINV2 APPEND    BLANKS,WSD          . ...in case read failed, clearing WSD
         RESET     WSD                 .
         SETLPTR   WSD, 5              . adjust size of description text
         RETURN                        .
*
         %IFNZ     IO$INV
IOKSINV  BRANCH    INV$OPN,IOX4INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX4INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITINV
IOQ$INV  READKS    INV; INV$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   INV$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READKS    INV;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
IOKPINV  BRANCH    INV$OPN,IOX3INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX3INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITINV
IOP$INV  READKP    INV; INV$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   INV$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READKP    INV;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITINV
.
IOESINV
         %IFZ      $EDITINV
         PACK      $KEYTEMP,FLDTYP,INV$KEY  . save param values
         CALL      INV$KEY             . build correctly formatted key
         MOVE      INV$KEY,WS          . deliver key result in WS
         MOVE      INV$KEY,INV$SVK     . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,INV$KEY  . restore param values
         %ELSE
         SETLPTR   WS,6                . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      INV,NULL;*17:
                   WSD;
         %ENDIF                        . closing $EDITINV
         GOTO      IOEKINV             . complete the description field
*
         %IFZ      $EDITINV
IOSQINV  MOVE      SEQ,$RECORD         . set up for physical seq'l read
IORRINV  BRANCH    INV$OPN,IOX5INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX5INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READSQ",IOMODE     .  and the I/O procedure
.
         READ      INV,$RECORD; INV$RLST . random or seq'l read
         GOTO      IORXINV             . perform post-read processing
         %ENDIF                        . closing $EDITINV
*
         %IFZ      $EDITINV
IOFRINV  BRANCH    INV$OPN,IOX6INV     . is this index now open ?
         CALL      IOPNINV             . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX6INV  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "RPOSIT",IOMODE     .  and the I/O procedure
.
         REPOSIT   INV,N9              . re-set the file cursor
         RETURN                        .
.
IOFPINV  FPOSIT    INV,N9              . get present file cursor
         RETURN                        .
         %ENDIF                        . closing $EDITINV
 
*
IOGZINV  IF        (INV$OPN = 0)       . is this index now open?
           CALL    IOPNINV             . no... then open it now
           BRANCH  IOFLAG,IOPRINV      . was index opened OK ?
         ENDIF
         READ      INV,SEQ3;;          . get total file size
IOGPINV  FPOSIT    INV,$FILPOSN        . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$INV
+
.  Read routines for index: '2' -- Customer - Invoice
.  --------------------------------------------------------------------
.
         %IFNZ     IO$INV2
IORKINV2 BRANCH    INV$OPN2,IOX1INV2   . is this index now open ?
         CALL      IOPNINV2            . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX1INV2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITINV
IOK$INV2 READ      INV2,INV$KEY2; INV$RLST . random access read
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READ      INV2,INV$KEY2;*17:  . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
         %IFZ      $EDITINV
IOTKINV2 BRANCH    INV$OPN2,IOX2INV2   . is this index now open ?
         CALL      IOPNINV2            . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX2INV2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      INV2,WS;;
         RETURN                        .
         %ENDIF
*
IOKSINV2 BRANCH    INV$OPN2,IOX4INV2   . is this index now open ?
         CALL      IOPNINV2            . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX4INV2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM2,FILENAME   . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITINV
IOQ$INV2 READKS    INV2; INV$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   INV$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READKS    INV2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
IOKPINV2 BRANCH    INV$OPN2,IOX3INV2   . is this index now open ?
         CALL      IOPNINV2            . no... then open it now
         BRANCH    IOFLAG,IOPRINV      . was index opened OK ?
IOX3INV2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM2,FILENAME   . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITINV
IOP$INV2 READKP    INV2; INV$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   INV$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXINV             . perform post-read processing
         %ELSE
.
         READKP    INV2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITINV
.
IOESINV2
         %IFZ      $EDITINV
         PACK      $KEYTEMP,FLDTYP,INV$KEY2 . save param values
         CALL      INV$KEY2            . build correctly formatted key
         MOVE      INV$KEY2,WS         . deliver key result in WS
         MOVE      INV$KEY2,INV$SVK2   . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,INV$KEY2 . restore param values
         %ELSE
         SETLPTR   WS,11               . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      INV2,NULL;*17:
                   WSD;
         %ENDIF                        . closing $EDITINV
         GOTO      IOEKINV             . complete the description field
 
*
IOGZINV2 IF        (INV$OPN2 = 0)      . is this index now open?
           CALL    IOPNINV2            . no... then open it now
           BRANCH  IOFLAG,IOPRINV      . was index opened OK ?
         ENDIF
         READ      INV2,SEQ3;;         . get total file size
IOGPINV2 FPOSIT    INV2,$FILPOSN       . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$INV2
*
.  Post processing to be performed following all full-record reads.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITINV
IORXINV  BRANCH    IOFLAG,IOPRINV      . exit now if I/O problem
         RETURN    IF OVER             . return with 'OVER' set
.
         MOVE      ZERO,N1             . clear the 'OVER' flag
         RETURN                        . return with 'OVER' clear
         %ENDIF                        . closing $EDITINV
+
.  Write routine for file: INV -- Invoice Master
.  ------------------------------------------------------------------
.
         %IFZ      $EDITINV
         %IFNZ     IO$INVWT
IOWUINV
         CALL      IOPNINVX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      INVCOLIS,C2         . prepare to increment counter
         CALL      $COUNTER            . for the updated record
         MOVE      C2,INVCOLIS         .
         GOTO      IOWVINV8            .
.
IOWTINV
         CALL      IOPNINVX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      $NWCOLIS,INVCOLIS   . initialize the update counter
.
         CALL      IOLVINV             . get new LVA value and set FILEPI
         BRANCH    IOFLAG,RETURN       . respond to error during LVA read
         RETURN    IF OVER             . no LVA value could be obtained
         CALL      INV$KEYX            . build all record keys for WRITE
         GOTO      IOWVINV9            . proceed to WRITE with FILEPI active
.
.   Write this record with pre-existing record key value(s)
.
IOWVINV8
         CALL      INV$KEYX            . build all record keys for WRITE
         IF (INV$OPNM = 1)             . was file opened shared ?
           FILEPI  99;INV              .   yes, enqueue the data file
         ENDIF
.>IOZ1INV
.
IOWVINV9
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "WRITE",IOMODE      .  and the I/O procedure
         WRITE     INV$FLST; INV$WLST  . This is an indexed write to filelist
         BRANCH    IOFLAG,IOWDINV      . respond to error during write
.
         FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful write
*
.  Come here to back the record out of the file if an error occurred
.  -----------------------------------------------------------------
.
IOWDINV  FILEPI    0                   . release data file enqueue
         RETURN                        . exit with record NOT written
         %ENDIF                        . closing IO$INVWT
*
.   Determine new LVA key value for write or update
.
.   ENTRY:
.      Record contents are filled for write or update
.   EXIT:
.      IOFLAG =1 if error     (the LVA key will be changed, not restored)
.      OVER is ON if no more sequence values are available
.      OVER is OFF and LVA field contains good value if all is OK
.
         %IFNZ     IO$INVWT,IO$INVUP   . compile for either update or write
IOLVINV
         MOVE      INV$KEY,$KEYTEMP    . save current value of key for update
         MOVE      INV$LVMX,INVINVNO   . begin probe at max key value
         CALL      INV$KEY             . build the key controlling this LVA
.
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "READLV",IOMODE     .  and the I/O procedure
         IF (INV$OPNM = 1)             . was file opened shared ?
           FILEPI  99;INV              .   yes, enqueue the data file
         ENDIF
.>IOZ4INV
.
.   Determine the new LVA record key
.
         READ      INV,INV$KEY;;       . position past last record in series
         BRANCH    IOFLAG, IOLVINVV
         GOTO      IOLVINVV IF NOT OVER  ...ERROR: max key is already in file
         READKP    INV; *3,  INVINVNO; . record has the last-used value
         BRANCH    IOFLAG, IOLVINVV
         GOTO      IOLVINV6 IF OVER    . no record; start a new sequence
         COMPARE   INV$LVFR,INVINVNO   . if prior value less than LVA range,
         GOTO      IOLVINV6 IF LESS    .   then start the new sequence
.
         ADD       INV$LVIN,INVINVNO   . continue existing number sequence
         GOTO      IOLVINVV IF OVER    .   overflow- can't get a new number
         COMPARE   INVINVNO,INV$LVMX   .   if new value would exceed LVA range,
         GOTO      IOLVINVV IF LESS    .   quit- no good new values available
         MOVE      $KEYTEMP,INV$KEY    . restore current value of this key
         RETURN                        . OVER is off - LV field value is good
.
IOLVINV6
         MOVE      $KEYTEMP,INV$KEY    . restore current value of this key
         MOVE      INV$LVFR,INVINVNO   . start new number sequence
         RETURN                        . OVER is off - LV field value is good
.
IOLVINVV
         FILEPI    0                   . cannot write or update record
         MOVE      $KEYTEMP,INV$KEY    . restore current value of this key
         SETFLAG   NOT EOS             . not showing other-user interference
         SETFLAG   OVER                . signal no sequence value available
         RETURN                        . ready to exit from IO module
         %ENDIF                        . closing (IO$INVWT,IO$INVUP)
         %ENDIF                        . closing $EDITINV
 
+
.  Delete routine for file: INV -- Invoice Master
.  -------------------------------------------------------------------
.
         %IFZ      $EDITINV
         %IFNZ     IO$INVDE
IODLINV  CALL      IOPNINVX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "DLREAD",IOMODE     .  and the I/O procedure
.
         IF (INV$OPNM = 1)             . was file opened shared ?
           FILEPI  99;INV              .   yes, enqueue the data file
         ENDIF
.>IOZ2INV
         READ      INV,INV$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IODXINV      . treat I/O error as missing key
         GOTO      IODXINV IF OVER     . did the record disappear ?
         MATCH     $RDCOLIS,INVCOLIS   . has it changed ?
         GOTO      IODCINV IF NOT EQUAL . yes...
         MOVE      ZERO,N1             . no missing keys yet
         MOVE      "DELETE",IOMODE     . remaining I/O will be delete
.
         DELETE    INV$FLST            . delete record and keys using filelist
         IF OVER
           MOVE    ONE,N1              . record key not found
         ENDIF                         . if I/O trap, just proceed with IOFLAG
         FILEPI    0                   . release data file enqueue
.
         BRANCH    N1,IODXINV          . report the missing key(s)
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit after successful delete
*
.  Come here if at least one key to be deleted was not found
.  ---------------------------------------------------------
.
IODXINV  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with partial or no delete
*
.  Come here if foreign update was detected during delete request
.  --------------------------------------------------------------
.
IODCINV  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no delete performed
         %ENDIF                        . closing IO$INVDE
         %ENDIF                        . closing $EDITINV
 
+
.  Update routine for file: INV -- Invoice Master
.  -------------------------------------------------------------------
.
         %IFZ      $EDITINV
         %IFNZ     IO$INVUP
IOUPINV
         CALL      IOPNINVX            . open all indexes
         BRANCH    IOFLAG,IOPRINV      . opened OK ?
.>IOX9INV
.
         IF (INV$OPNM = 1)             . was file opened shared ?
           FILEPI  99;INV              .   yes, enqueue the data file
         ENDIF
.>IOZ3INV
.
         MOVE      INVCOLIS,C2         . assume update will succeed, and
         CALL      $COUNTER            . increment the counter character
.
         MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      INV$FNM,FILENAME    . set the disk file name
         MOVE      "UPREAD",IOMODE     .  and the I/O procedure
         READ      INV,INV$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IOUXINV      . treat I/O error as missing key
         GOTO      IOUXINV IF OVER     . has the record disappeared ?
         MATCH     INVCOLIS,$RDCOLIS   . has the counter changed ?
         GOTO      IOUCINV IF NOT EQUAL . yes...
         MOVE      C2,INVCOLIS         . increment the record counter
         MOVE      "UPDATE",IOMODE     .
         UPDATE    INV$FLST; INV$WLST  . update record in place by filelist
         FILEPI    0                   . release data file enqueue
 
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful update
*
.  Come here if foreign update was detected during field changes
.  -------------------------------------------------------------
.
IOUCINV  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no update performed
*
.  Come here if I/O error, or record disappeared during field changes
.  ------------------------------------------------------------------
.
IOUXINV  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with error or lost record
         %ENDIF                        . closing IO$INVUP
         %ENDIF                        . closing $EDITINV
+
.  Convert special storage format:  From AIM key memory to file format
.  -------------------------------------------------------------------
.  Entry:
.     C5  = 5-char field name
.     WS2 = AIM search string to be converted
.     $AIMFLDN = aim field number
.     $AIMTYPE = user's selected match type
.  Exit:
.     WS2 = converted result ready to go into $AIMKTRN(j)
.
         %IFZ      $EDITINV
IOXLINV
         RETURN
         %ENDIF                        . closing $EDITINV
+
.  Data handling for Array: CHG -- 5 Lines of Service Charges
.  -------------------------------------------------------------------
.
*
.  Entry points for LOAD & STORES - one complete row of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITINV
LDINVCHG
         CALL      LDINV025            . Description
         CALL      LDINV030            . Item Amount
         RETURN                        .
STINVCHG
         CALL      STINV025            . Description
         CALL      STINV030            . Item Amount
         RETURN                        .
         %ENDIF                        . closing $EDITINV
*
.  Entry points for LOAD & STORE - individual field of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITINV
LDINV025 LOAD      INVDESCR,LINENO:
                   INV02501,INV02502,INV02503,INV02504,INV02505
         RETURN                        .
STINV025 STORE     INVDESCR,LINENO:
                   INV02501,INV02502,INV02503,INV02504,INV02505
         RETURN                        .
LDINV030 LOAD      INVCHARG,LINENO:
                   INV03001,INV03002,INV03003,INV03004,INV03005
         RETURN                        .
STINV030 STORE     INVCHARG,LINENO:
                   INV03001,INV03002,INV03003,INV03004,INV03005
         RETURN                        .
         %ENDIF                        . closing $EDITINV
.
.   The following label is referenced by the file maintenance program solely
.   to verify that this .IO module will update isam and aim keys if changed
.   (feature new in version 2.9.1).  When a new F.M.P. tries to include an
.   older .IO module, this label will be undefined and will prevent compilation
.   because that is not supported. Upon seeing this label undefined, the
.   programmer should regenerate the file's .IO module.
.
IOVRINV_please_Regen  RETURN           . (never really executed)
.
         endif     . closing if (0) - allows including at top of program
         %ENDIF    . closing IO$INVIO - allow multiple including
.
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.*               END OF I/O ROUTINE SOURCE CODE - DEMOINV.IO
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 
