+               ** FILE INPUT/OUTPUT STATEMENTS ROUTINES **
.             ===============================================
.
.                      Input/Output Section for File:
.
.                  PAY -- Customer Payments
.                 --------------------------------------------
.
.  This 'INCLUDE' module contains all routines required to perform I/O
.  with the PAY data file. These routines are normally the only ones to
.  be used when accessing this data file.
.
.
.   Created by SYSTEMAKER ver. 2.10     on 04/28/03 at 17:02
.
.   (Code is tailored for the Sunbelt  P L / B  compiler)
.
.
. *------------*            DATABASE MANAGEMENT SYSTEM
. | SYSTEMAKER |         APPLICATION SOURCE CODE GENERATOR
. *------------*      INFOPRO, Inc. Aurora, IL 60504 (USA)
.
.                      +-----------------------------------+
.                      |           Infopro, Inc.           |
.   License no.: 9999  |        2920 Norwalk Court         |
.    & Site no.: 9999  |       Aurora, IL 60504-1310       |
.                      |    ** IN-HOUSE DEVELOPMENT **     |
.                      +-----------------------------------+
.
         %IFNDEF   IO$PAYIO            . allow multiple including
IO$PAYIO EQU       1                   . I/O module has been included
 
         %IFNDEF   PAY$OPNX            . VAR module not here yet?
         INCLUDE   DEMOPAY/VAR         .    include it now
         %ENDIF
         if (0)                        . allow including at top of program
+
.  Key building routines for: PAY -- Customer Payments
.  ---------------------------------------------------------------------
.
*
         %IFZ      $EDITPAY
         %IFNZ     IO$PAY
PAY$KEY  PACK      PAY$KEY,PAYINVNO:   . Invoice Number:
                            PAYPAYNO   . Payment Number:
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$PAY
         %ENDIF                        . closing $EDITPAY
*
         %IFZ      $EDITPAY
         %IFNZ     IO$PAY2
PAY$KEY2 CLEAR     PAY$KEY2            . record key '2' contains...
         APPEND    PAYCUSNO,PAY$KEY2   . Customer Number:
         APPEND    PAYINVNO,PAY$KEY2   . Invoice Number:
         MOVE      PAYPAYDT,WS2        . Payment Date:
         MOVE      "3",FLDTYP          . needs storage form conversion
         MOVE      "0",INPCODE         . standard storage formatting
         CALL      $STORAGE            . perform storage conversion
         APPEND    WS2,PAY$KEY2        .
         APPEND    PAYPAYNO,PAY$KEY2   . Payment Number:
         RESET     PAY$KEY2            .
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$PAY2
         %ENDIF                        . closing $EDITPAY
*
.  Build all the keys for this record
.
         %IFZ      $EDITPAY
PAY$KEYX
         %IFNZ     IO$PAY
         CALL      PAY$KEY             . Primary ISAM index
         %ENDIF                        . closing IO$PAY
         %IFNZ     IO$PAY2
         CALL      PAY$KEY2            . by Customer, Invoice, Payment Date
         %ENDIF                        . closing IO$PAY2
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
*
.  Routine to clear all record image variables. Exit: OVER flag is set.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITPAY
IONLPAY  UNPACK    NULL, PAY$MLST      . Blank/Clear/Zero all vars
         MOVE      "10",N1             . Set 'OVER' flag showing read failed
         RETURN                        . Exit with OVER flag giving result
         %ENDIF                        . closing $EDITPAY
+
.  Open routines for file: PAY -- Customer Payments
.  ------------------------------------------------------------------
.
*
.  Open all related indices to the file
.  ------------------------------------
.
IOPNPAYX MOVE      ZERO,IOFLAG         . clear the I/O error flag
         BRANCH    PAY$OPNX,RETURN     . do nothing if all indexes now open
         %IFNZ     IO$PAY
         CALL      IOPNPAY             . Primary ISAM index
         BRANCH    IOFLAG,IOPRPAY      .
         %ENDIF                        . closing IO$PAY
         %IFNZ     IO$PAY2
         CALL      IOPNPAY2            . by Customer, Invoice, Payment Date
         BRANCH    IOFLAG,IOPRPAY      .
         %ENDIF                        . closing IO$PAY2
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYA
         CALL      IOPNPAYA            . Invoice - Customer - Date - Descrip
         BRANCH    IOFLAG,IOPRPAY      .
         %ENDIF                        . closing IO$PAYA
         %ENDIF                        . closing $EDITPAY
         MOVE      ONE,PAY$OPNX        . indicate all indexes now open
IOPRPAY  RETURN                        .
*
.  Open (index) file: PAY -- Primary ISAM index
.  --------------------------------------------------------------
.
         %IFNZ     IO$PAY
IOPNPAY  MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    PAY$OPN,IOPXPAY     . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      PAY$FNM,$BLDFNMN    . build this file name
         MOVE      "PAY",  $BLDFNMF    . for file code: 'PAY'
         MOVE      NULL,   $BLDFNMI    . and index code: ' '
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,PAY$FNM    . set local name variable
         MOVE      PAY$FNM,FILENAME    . set file name for error msg
         BRANCH    PAY$OPNM,IOP1PAY,IOP2PAY,IOP3PAY
.                           shared     read   exclusive
IOP1PAY  OPEN      PAY,$BLDFNMX
         GOTO      IOP0PAY             .
IOP2PAY  OPEN      PAY,$BLDFNMX,READ
         GOTO      IOP0PAY             .
IOP3PAY  OPEN      PAY,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0PAY             .
IOP0PAY  BRANCH    IOFLAG,IOPXPAY      . was it found ?
         MOVE      ONE,PAY$OPN         . the PAY index is now open
IOPXPAY  RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$PAY
*
.  Open (index) file: PAY2 -- by Customer, Invoice, Payment Date
.  --------------------------------------------------------------
.
         %IFNZ     IO$PAY2
IOPNPAY2 MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    PAY$OPN2,IOPXPAY2   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      PAY$FNM2,$BLDFNMN   . build this file name
         MOVE      "PAY",   $BLDFNMF   . for file code: 'PAY'
         MOVE      "2",     $BLDFNMI   . and index code: '2'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,PAY$FNM2   . set local name variable
         MOVE      PAY$FNM2,FILENAME   . set file name for error msg
         BRANCH    PAY$OPNM,IOP1PAY2,IOP2PAY2,IOP3PAY2
.                           shared     read   exclusive
IOP1PAY2 OPEN      PAY2,$BLDFNMX
         GOTO      IOP0PAY2            .
IOP2PAY2 OPEN      PAY2,$BLDFNMX,READ
         GOTO      IOP0PAY2            .
IOP3PAY2 OPEN      PAY2,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0PAY2            .
IOP0PAY2 BRANCH    IOFLAG,IOPXPAY2     . was it found ?
         MOVE      ONE,PAY$OPN2        . the PAY2 index is now open
IOPXPAY2 RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$PAY2
*
.  Open (index) file: PAYA -- Invoice - Customer - Date - Descrip
.  --------------------------------------------------------------
.
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYA
IOPNPAYA MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    PAY$OPNA,IOPXPAYA   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      PAY$FNMA,$BLDFNMN   . build this file name
         MOVE      "PAY",   $BLDFNMF   . for file code: 'PAY'
         MOVE      "A",     $BLDFNMI   . and index code: 'A'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,PAY$FNMA   . set local name variable
         MOVE      PAY$FNMA,FILENAME   . set file name for error msg
         BRANCH    PAY$OPNM,IOP1PAYA,IOP2PAYA,IOP3PAYA
.                           shared     read   exclusive
IOP1PAYA OPEN      PAYA,$BLDFNMX
         GOTO      IOP0PAYA            .
IOP2PAYA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      PAYA,$BLDFNMX,READ
         %ELSE
         OPEN      PAYA,$BLDFNMX,,READ
         %ENDIF
         GOTO      IOP0PAYA            .
IOP3PAYA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      PAYA,$BLDFNMX,EXCLUSIVE
         %ELSE
         OPEN      PAYA,$BLDFNMX,,EXCLUSIVE
         %ENDIF
         GOTO      IOP0PAYA            .
IOP0PAYA BRANCH    IOFLAG,IOPXPAYA     . was it found ?
         MOVE      ONE,PAY$OPNA        . the PAYA index is now open
IOPXPAYA RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$PAYA
         %ENDIF                        . closing $EDITPAY
+
.  Read routines for index: ' ' -- Primary ISAM index
.  --------------------------------------------------------------------
.
         %IFNZ     IO$PAY
IORKPAY  BRANCH    PAY$OPN,IOX1PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX1PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOK$PAY  READ      PAY,PAY$KEY; PAY$RLST . random access read
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READ      PAY,PAY$KEY;*23:    . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
*
         %IFZ      $EDITPAY
IOTKPAY  BRANCH    PAY$OPN,IOX2PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX2PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      PAY,WS;;
         RETURN                        .
         %ENDIF
*
         %ENDIF                        . closing IO$PAY
 
IOEKPAY
         %IFZ      $EDITPAY
         UNPACK    PAYTYPE,WSD         . get description field contents
         %ENDIF
         TYPE      WSD                 . is this a null description?
         GOTO      IOEKPAY2 IF EOS     . ...yes, make sure it's completely null
         ENDSET    WSD                 . pad with trailing blanks
IOEKPAY2 APPEND    BLANKS,WSD          . ...in case read failed, clearing WSD
         RESET     WSD                 .
         SETLPTR   WSD,25              . adjust size of description text
         RETURN                        .
*
         %IFNZ     IO$PAY
IOKSPAY  BRANCH    PAY$OPN,IOX4PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX4PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOQ$PAY  READKS    PAY; PAY$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   PAY$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READKS    PAY;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
*
IOKPPAY  BRANCH    PAY$OPN,IOX3PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX3PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOP$PAY  READKP    PAY; PAY$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   PAY$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READKP    PAY;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
.
IOESPAY
         %IFZ      $EDITPAY
         PACK      $KEYTEMP,FLDTYP,PAY$KEY  . save param values
         CALL      PAY$KEY             . build correctly formatted key
         MOVE      PAY$KEY,WS          . deliver key result in WS
         MOVE      PAY$KEY,PAY$SVK     . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,PAY$KEY  . restore param values
         %ELSE
         SETLPTR   WS,9                . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      PAY,NULL;*23:
                   WSD;
         %ENDIF                        . closing $EDITPAY
         GOTO      IOEKPAY             . complete the description field
*
         %IFZ      $EDITPAY
IOSQPAY  MOVE      SEQ,$RECORD         . set up for physical seq'l read
IORRPAY  BRANCH    PAY$OPN,IOX5PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX5PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READSQ",IOMODE     .  and the I/O procedure
.
         READ      PAY,$RECORD; PAY$RLST . random or seq'l read
         GOTO      IORXPAY             . perform post-read processing
         %ENDIF                        . closing $EDITPAY
*
         %IFZ      $EDITPAY
IOFRPAY  BRANCH    PAY$OPN,IOX6PAY     . is this index now open ?
         CALL      IOPNPAY             . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX6PAY  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "RPOSIT",IOMODE     .  and the I/O procedure
.
         REPOSIT   PAY,N9              . re-set the file cursor
         RETURN                        .
.
IOFPPAY  FPOSIT    PAY,N9              . get present file cursor
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
 
*
IOGZPAY  IF        (PAY$OPN = 0)       . is this index now open?
           CALL    IOPNPAY             . no... then open it now
           BRANCH  IOFLAG,IOPRPAY      . was index opened OK ?
         ENDIF
         READ      PAY,SEQ3;;          . get total file size
IOGPPAY  FPOSIT    PAY,$FILPOSN        . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$PAY
+
.  Read routines for index: '2' -- by Customer, Invoice, Payment Date
.  --------------------------------------------------------------------
.
         %IFNZ     IO$PAY2
IORKPAY2 BRANCH    PAY$OPN2,IOX1PAY2   . is this index now open ?
         CALL      IOPNPAY2            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX1PAY2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOK$PAY2 READ      PAY2,PAY$KEY2; PAY$RLST . random access read
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READ      PAY2,PAY$KEY2;*23:  . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
*
         %IFZ      $EDITPAY
IOTKPAY2 BRANCH    PAY$OPN2,IOX2PAY2   . is this index now open ?
         CALL      IOPNPAY2            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX2PAY2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      PAY2,WS;;
         RETURN                        .
         %ENDIF
*
IOKSPAY2 BRANCH    PAY$OPN2,IOX4PAY2   . is this index now open ?
         CALL      IOPNPAY2            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX4PAY2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM2,FILENAME   . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOQ$PAY2 READKS    PAY2; PAY$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   PAY$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READKS    PAY2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
*
IOKPPAY2 BRANCH    PAY$OPN2,IOX3PAY2   . is this index now open ?
         CALL      IOPNPAY2            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX3PAY2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM2,FILENAME   . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITPAY
IOP$PAY2 READKP    PAY2; PAY$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   PAY$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXPAY             . perform post-read processing
         %ELSE
.
         READKP    PAY2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITPAY
.
IOESPAY2
         %IFZ      $EDITPAY
         PACK      $KEYTEMP,FLDTYP,PAY$KEY2 . save param values
         CALL      PAY$KEY2            . build correctly formatted key
         MOVE      PAY$KEY2,WS         . deliver key result in WS
         MOVE      PAY$KEY2,PAY$SVK2   . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,PAY$KEY2 . restore param values
         %ELSE
         SETLPTR   WS,20               . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      PAY2,NULL;*23:
                   WSD;
         %ENDIF                        . closing $EDITPAY
         GOTO      IOEKPAY             . complete the description field
 
*
IOGZPAY2 IF        (PAY$OPN2 = 0)      . is this index now open?
           CALL    IOPNPAY2            . no... then open it now
           BRANCH  IOFLAG,IOPRPAY      . was index opened OK ?
         ENDIF
         READ      PAY2,SEQ3;;         . get total file size
IOGPPAY2 FPOSIT    PAY2,$FILPOSN       . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$PAY2
+
.  Read routines for index: 'A' -- Invoice - Customer - Date - Descrip
.  --------------------------------------------------------------------
.
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYA
IORKPAYA BRANCH    PAY$OPNA,IOX1PAYA   . is this index now open ?
         CALL      IOPNPAYA            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX1PAYA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNMA,FILENAME   . set the disk file name
         MOVE      "AMREAD",IOMODE     .  and the I/O procedure
.
IOK$PAYA READ      PAYA,$AIMKLST; PAY$RLST . this is an AIM read
         GOTO      IORXPAY             . perform post-read processing
*
IOKSPAYA BRANCH    PAY$OPNA,IOX4PAYA   . is this index now open ?
         CALL      IOPNPAYA            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX4PAYA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNMA,FILENAME   . set the disk file name
         MOVE      "READKG",IOMODE     .  and the I/O procedure
.
IOQ$PAYA READKG    PAYA; PAY$RLST      . for next generic key
         GOTO      IORXPAY             . perform post-read processing
*
         %IFNZ     C$READGP
IOKPPAYA BRANCH    PAY$OPNA,IOX3PAYA   . is this index now open ?
         CALL      IOPNPAYA            . no... then open it now
         BRANCH    IOFLAG,IOPRPAY      . was index opened OK ?
IOX3PAYA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNMA,FILENAME   . set the disk file name
         MOVE      "RDKGP ",IOMODE     .  and the I/O procedure
.
IOP$PAYA READKGP   PAYA; PAY$RLST      . read for prior generic key
         GOTO      IORXPAY             . perform post-read processing
         %ENDIF                        . closing C$READGP
*
IOGZPAYA IF        (PAY$OPNA = 0)      . is this index now open?
           CALL    IOPNPAYA            . no... then open it now
           BRANCH  IOFLAG,IOPRPAY      . was index opened OK ?
         ENDIF
         READ      PAYA,SEQ3;;         . get total file size
IOGPPAYA FPOSIT    PAYA,$FILPOSN       . get present file position
         RETURN                        .
         %ENDIF                        . closing IO$PAYA
         %ENDIF                        . closing $EDITPAY
*
.  Post processing to be performed following all full-record reads.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITPAY
IORXPAY  BRANCH    IOFLAG,IOPRPAY      . exit now if I/O problem
         RETURN    IF OVER             . return with 'OVER' set
.
         %IFNZ     IO$PAYWT,IO$PAYUP
         PACK      PAY$LVRK, PAYINVNO  . save record's LVA key prefix value
         %ENDIF
.
         MOVE      ZERO,N1             . clear the 'OVER' flag
         RETURN                        . return with 'OVER' clear
         %ENDIF                        . closing $EDITPAY
+
.  Write routine for file: PAY -- Customer Payments
.  ------------------------------------------------------------------
.
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYWT
IOWUPAY
         CALL      IOPNPAYX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      PAYCOLIS,C2         . prepare to increment counter
         CALL      $COUNTER            . for the updated record
         MOVE      C2,PAYCOLIS         .
         PACK      $KEYTEMP, PAYINVNO  . form the key-prefix fields
         MATCH     $KEYTEMP, PAY$LVRK  . changed since the record was read?
         GOTO      IOWVPAY8 IF EQUAL   . ...no, go rewrite with existing key
         GOTO      IOWVPAY2            . ...yes; go make up a new key
.
IOWTPAY
         CALL      IOPNPAYX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      $NWCOLIS,PAYCOLIS   . initialize the update counter
.
IOWVPAY2
         CALL      IOLVPAY             . get new LVA value and set FILEPI
         BRANCH    IOFLAG,RETURN       . respond to error during LVA read
         RETURN    IF OVER             . no LVA value could be obtained
         CALL      PAY$KEYX            . build all record keys for WRITE
         GOTO      IOWVPAY9            . proceed to WRITE with FILEPI active
.
.   Write this record with pre-existing record key value(s)
.
IOWVPAY8
         CALL      PAY$KEYX            . build all record keys for WRITE
         IF (PAY$OPNM = 1)             . was file opened shared ?
           FILEPI  99;PAY              .   yes, enqueue the data file
         ENDIF
.>IOZ1PAY
.
IOWVPAY9
         PACK      PAY$LVRK, PAYINVNO  . save record's LVA key prefix value
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "WRITE",IOMODE      .  and the I/O procedure
         WRITE     PAY$FLST; PAY$WLST  . This is an indexed write to filelist
         BRANCH    IOFLAG,IOWDPAY      . respond to error during write
.
         FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful write
*
.  Come here to back the record out of the file if an error occurred
.  -----------------------------------------------------------------
.
IOWDPAY  FILEPI    0                   . release data file enqueue
         RETURN                        . exit with record NOT written
         %ENDIF                        . closing IO$PAYWT
*
.   Determine new LVA key value for write or update
.
.   ENTRY:
.      Record contents are filled for write or update
.   EXIT:
.      IOFLAG =1 if error     (the LVA key will be changed, not restored)
.      OVER is ON if no more sequence values are available
.      OVER is OFF and LVA field contains good value if all is OK
.
         %IFNZ     IO$PAYWT,IO$PAYUP   . compile for either update or write
IOLVPAY
         MOVE      PAY$KEY,$KEYTEMP    . save current value of key for update
         MOVE      PAY$LVMX,PAYPAYNO   . begin probe at max key value
         CALL      PAY$KEY             . build the key controlling this LVA
.
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "READLV",IOMODE     .  and the I/O procedure
         IF (PAY$OPNM = 1)             . was file opened shared ?
           FILEPI  99;PAY              .   yes, enqueue the data file
         ENDIF
.>IOZ4PAY
.
.   Determine the new LVA record key
.
         READ      PAY,PAY$KEY;;       . position past last record in series
         BRANCH    IOFLAG, IOLVPAYV
         GOTO      IOLVPAYV IF NOT OVER  ...ERROR: max key is already in file
         READKP    PAY; *3,  PAY$LV1:  . record has the last-used value
                          *14,  PAYPAYNO;
         BRANCH    IOFLAG, IOLVPAYV
         GOTO      IOLVPAY6 IF OVER    . no record; start a new sequence
         PACK      PAY$LVRK, PAY$LV1   . form the key-prefix fields
         MATCH     PAY$LVRK,PAY$KEY    . if we found a record, and its upper...
         GOTO      IOLVPAY6 IF NOT EQUAL  ... key fields match ...
         COMPARE   PAY$LVFR,PAYPAYNO   . if prior value less than LVA range,
         GOTO      IOLVPAY6 IF LESS    .   then start the new sequence
.
         ADD       PAY$LVIN,PAYPAYNO   . continue existing number sequence
         GOTO      IOLVPAYV IF OVER    .   overflow- can't get a new number
         COMPARE   PAYPAYNO,PAY$LVMX   .   if new value would exceed LVA range,
         GOTO      IOLVPAYV IF LESS    .   quit- no good new values available
         MOVE      $KEYTEMP,PAY$KEY    . restore current value of this key
         RETURN                        . OVER is off - LV field value is good
.
IOLVPAY6
         MOVE      $KEYTEMP,PAY$KEY    . restore current value of this key
         MOVE      PAY$LVFR,PAYPAYNO   . start new number sequence
         RETURN                        . OVER is off - LV field value is good
.
IOLVPAYV
         FILEPI    0                   . cannot write or update record
         MOVE      $KEYTEMP,PAY$KEY    . restore current value of this key
         SETFLAG   NOT EOS             . not showing other-user interference
         SETFLAG   OVER                . signal no sequence value available
         RETURN                        . ready to exit from IO module
         %ENDIF                        . closing (IO$PAYWT,IO$PAYUP)
         %ENDIF                        . closing $EDITPAY
 
+
.  Delete routine for file: PAY -- Customer Payments
.  -------------------------------------------------------------------
.
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYDE
IODLPAY  CALL      IOPNPAYX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "DLREAD",IOMODE     .  and the I/O procedure
.
         IF (PAY$OPNM = 1)             . was file opened shared ?
           FILEPI  99;PAY              .   yes, enqueue the data file
         ENDIF
.>IOZ2PAY
         READ      PAY,PAY$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IODXPAY      . treat I/O error as missing key
         GOTO      IODXPAY IF OVER     . did the record disappear ?
         MATCH     $RDCOLIS,PAYCOLIS   . has it changed ?
         GOTO      IODCPAY IF NOT EQUAL . yes...
         MOVE      ZERO,N1             . no missing keys yet
         MOVE      "DELETE",IOMODE     . remaining I/O will be delete
.
         DELETE    PAY$FLST            . delete record and keys using filelist
         IF OVER
           MOVE    ONE,N1              . record key not found
         ENDIF                         . if I/O trap, just proceed with IOFLAG
         FILEPI    0                   . release data file enqueue
.
         BRANCH    N1,IODXPAY          . report the missing key(s)
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit after successful delete
*
.  Come here if at least one key to be deleted was not found
.  ---------------------------------------------------------
.
IODXPAY  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with partial or no delete
*
.  Come here if foreign update was detected during delete request
.  --------------------------------------------------------------
.
IODCPAY  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no delete performed
         %ENDIF                        . closing IO$PAYDE
         %ENDIF                        . closing $EDITPAY
 
+
.  Update routine for file: PAY -- Customer Payments
.  -------------------------------------------------------------------
.
         %IFZ      $EDITPAY
         %IFNZ     IO$PAYUP
IOUPPAY
         CALL      IOPNPAYX            . open all indexes
         BRANCH    IOFLAG,IOPRPAY      . opened OK ?
.>IOX9PAY
         PACK      $KEYTEMP, PAYINVNO  . form the key-prefix fields
         IF ($KEYTEMP <> PAY$LVRK)     . changed since the record was read?
           CALL    IOLVPAY             . get new LVA value and set FILEPI
           BRANCH  IOFLAG,RETURN       . respond to error during LVA read
           RETURN  IF OVER             . no LVA value could be obtained
         ELSE                          . LVA key not changed
.
         IF (PAY$OPNM = 1)             . was file opened shared ?
           FILEPI  99;PAY              .   yes, enqueue the data file
         ENDIF
.>IOZ3PAY
         ENDIF                         . closing ($KEYTEMP <> lva key)
.
         MOVE      PAYCOLIS,C2         . assume update will succeed, and
         CALL      $COUNTER            . increment the counter character
.
         MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      PAY$FNM,FILENAME    . set the disk file name
         MOVE      "UPREAD",IOMODE     .  and the I/O procedure
         READ      PAY,PAY$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IOUXPAY      . treat I/O error as missing key
         GOTO      IOUXPAY IF OVER     . has the record disappeared ?
         MATCH     PAYCOLIS,$RDCOLIS   . has the counter changed ?
         GOTO      IOUCPAY IF NOT EQUAL . yes...
         MOVE      C2,PAYCOLIS         . increment the record counter
         MOVE      "UPDATE",IOMODE     .
         UPDATE    PAY$FLST; PAY$WLST  . update record in place by filelist
         FILEPI    0                   . release data file enqueue
 
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful update
*
.  Come here if foreign update was detected during field changes
.  -------------------------------------------------------------
.
IOUCPAY  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no update performed
*
.  Come here if I/O error, or record disappeared during field changes
.  ------------------------------------------------------------------
.
IOUXPAY  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with error or lost record
         %ENDIF                        . closing IO$PAYUP
         %ENDIF                        . closing $EDITPAY
+
.  Convert special storage format:  From AIM key memory to file format
.  -------------------------------------------------------------------
.  Entry:
.     C5  = 5-char field name
.     WS2 = AIM search string to be converted
.     $AIMFLDN = aim field number
.     $AIMTYPE = user's selected match type
.  Exit:
.     WS2 = converted result ready to go into $AIMKTRN(j)
.
         %IFZ      $EDITPAY
IOXLPAY
         RETURN
         %ENDIF                        . closing $EDITPAY
.
.   The following label is referenced by the file maintenance program solely
.   to verify that this .IO module will update isam and aim keys if changed
.   (feature new in version 2.9.1).  When a new F.M.P. tries to include an
.   older .IO module, this label will be undefined and will prevent compilation
.   because that is not supported. Upon seeing this label undefined, the
.   programmer should regenerate the file's .IO module.
.
IOVRPAY_please_Regen  RETURN           . (never really executed)
.
         endif     . closing if (0) - allows including at top of program
         %ENDIF    . closing IO$PAYIO - allow multiple including
.
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.*               END OF I/O ROUTINE SOURCE CODE - DEMOPAY.IO
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 
