+               ** FILE INPUT/OUTPUT STATEMENTS ROUTINES **
.             ===============================================
.
.                      Input/Output Section for File:
.
.                  CUS -- Customer File
.                 --------------------------------------------
.
.  This 'INCLUDE' module contains all routines required to perform I/O
.  with the CUS data file. These routines are normally the only ones to
.  be used when accessing this data file.
.
.
.   Created by SYSTEMAKER ver. 2.10     on 02/14/03 at 15:37
.
.   (Code is tailored for the Sunbelt  P L / B  compiler)
.
.
. *------------*            DATABASE MANAGEMENT SYSTEM
. | SYSTEMAKER |         APPLICATION SOURCE CODE GENERATOR
. *------------*      INFOPRO, Inc. Aurora, IL 60504 (USA)
.
.                      +-----------------------------------+
.                      |           Infopro, Inc.           |
.   License no.: 9999  |       2625 Butterfield Road       |
.    & Site no.: 9999  |        Oak Brook, IL  USA         |
.                      |    ** IN-HOUSE DEVELOPMENT **     |
.                      +-----------------------------------+
.
         %IFNDEF   IO$CUSIO            . allow multiple including
IO$CUSIO EQU       1                   . I/O module has been included
 
         %IFNDEF   CUS$OPNX            . VAR module not here yet?
         INCLUDE   DEMOCUS/VAR         .    include it now
         %ENDIF
         if (0)                        . allow including at top of program
+
.  Key building routines for: CUS -- Customer File
.  ---------------------------------------------------------------------
.
*
         %IFZ      $EDITCUS
         %IFNZ     IO$CUS
CUS$KEY  MOVE      CUSCUSNO,CUS$KEY    . Customer Number:
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$CUS
         %ENDIF                        . closing $EDITCUS
*
         %IFZ      $EDITCUS
         %IFNZ     IO$CUS2
CUS$KEY2 PACK      CUS$KEY2,CUSNAME:   . Customer Name..:
                            CUSCUSNO   . Customer Number:
         RETURN                        . done... key is constructed
         %ENDIF                        . closing IO$CUS2
         %ENDIF                        . closing $EDITCUS
*
.  Build all the keys for this record
.
         %IFZ      $EDITCUS
CUS$KEYX
         %IFNZ     IO$CUS
         CALL      CUS$KEY             . Primary ISAM index
         %ENDIF                        . closing IO$CUS
         %IFNZ     IO$CUS2
         CALL      CUS$KEY2            . Alpha by Customer
         %ENDIF                        . closing IO$CUS2
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
.  Routine to clear all record image variables. Exit: OVER flag is set.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCUS
IONLCUS  UNPACK    NULL, CUS$MLST      . Blank/Clear/Zero all vars
         MOVE      "10",N1             . Set 'OVER' flag showing read failed
         RETURN                        . Exit with OVER flag giving result
         %ENDIF                        . closing $EDITCUS
+
.  Open routines for file: CUS -- Customer File
.  ------------------------------------------------------------------
.
*
.  Open all related indices to the file
.  ------------------------------------
.
IOPNCUSX MOVE      ZERO,IOFLAG         . clear the I/O error flag
         BRANCH    CUS$OPNX,RETURN     . do nothing if all indexes now open
         %IFNZ     IO$CUS
         CALL      IOPNCUS             . Primary ISAM index
         BRANCH    IOFLAG,IOPRCUS      .
         %ENDIF                        . closing IO$CUS
         %IFNZ     IO$CUS2
         CALL      IOPNCUS2            . Alpha by Customer
         BRANCH    IOFLAG,IOPRCUS      .
         %ENDIF                        . closing IO$CUS2
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSA
         CALL      IOPNCUSA            . General AIM Index
         BRANCH    IOFLAG,IOPRCUS      .
         %ENDIF                        . closing IO$CUSA
         %ENDIF                        . closing $EDITCUS
         MOVE      ONE,CUS$OPNX        . indicate all indexes now open
IOPRCUS  RETURN                        .
*
.  Open (index) file: CUS -- Primary ISAM index
.  --------------------------------------------------------------
.
         %IFNZ     IO$CUS
IOPNCUS  MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    CUS$OPN,IOPXCUS     . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      CUS$FNM,$BLDFNMN    . build this file name
         MOVE      "CUS",  $BLDFNMF    . for file code: 'CUS'
         MOVE      NULL,   $BLDFNMI    . and index code: ' '
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,CUS$FNM    . set local name variable
         MOVE      CUS$FNM,FILENAME    . set file name for error msg
         BRANCH    CUS$OPNM,IOP1CUS,IOP2CUS,IOP3CUS
.                           shared     read   exclusive
IOP1CUS  OPEN      CUS,$BLDFNMX
         GOTO      IOP0CUS             .
IOP2CUS  OPEN      CUS,$BLDFNMX,READ
         GOTO      IOP0CUS             .
IOP3CUS  OPEN      CUS,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0CUS             .
IOP0CUS  BRANCH    IOFLAG,IOPXCUS      . was it found ?
         MOVE      ONE,CUS$OPN         . the CUS index is now open
IOPXCUS  RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$CUS
*
.  Open (index) file: CUS2 -- Alpha by Customer
.  --------------------------------------------------------------
.
         %IFNZ     IO$CUS2
IOPNCUS2 MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    CUS$OPN2,IOPXCUS2   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      CUS$FNM2,$BLDFNMN   . build this file name
         MOVE      "CUS",   $BLDFNMF   . for file code: 'CUS'
         MOVE      "2",     $BLDFNMI   . and index code: '2'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,CUS$FNM2   . set local name variable
         MOVE      CUS$FNM2,FILENAME   . set file name for error msg
         BRANCH    CUS$OPNM,IOP1CUS2,IOP2CUS2,IOP3CUS2
.                           shared     read   exclusive
IOP1CUS2 OPEN      CUS2,$BLDFNMX
         GOTO      IOP0CUS2            .
IOP2CUS2 OPEN      CUS2,$BLDFNMX,READ
         GOTO      IOP0CUS2            .
IOP3CUS2 OPEN      CUS2,$BLDFNMX,EXCLUSIVE
         GOTO      IOP0CUS2            .
IOP0CUS2 BRANCH    IOFLAG,IOPXCUS2     . was it found ?
         MOVE      ONE,CUS$OPN2        . the CUS2 index is now open
IOPXCUS2 RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$CUS2
*
.  Open (index) file: CUSA -- General AIM Index
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSA
IOPNCUSA MOVE      ZERO,IOFLAG         . clear the error flag
         BRANCH    CUS$OPNA,IOPXCUSA   . bypass if file already open
         MOVE      "OPEN",IOMODE       . set the I/O activity indicator
         MOVE      CUS$FNMA,$BLDFNMN   . build this file name
         MOVE      "CUS",   $BLDFNMF   . for file code: 'CUS'
         MOVE      "A",     $BLDFNMI   . and index code: 'A'
         CALL      $BLDFNM             . now build the file name
         MOVE      $BLDFNMN,CUS$FNMA   . set local name variable
         MOVE      CUS$FNMA,FILENAME   . set file name for error msg
         BRANCH    CUS$OPNM,IOP1CUSA,IOP2CUSA,IOP3CUSA
.                           shared     read   exclusive
IOP1CUSA OPEN      CUSA,$BLDFNMX
         GOTO      IOP0CUSA            .
IOP2CUSA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      CUSA,$BLDFNMX,READ
         %ELSE
         OPEN      CUSA,$BLDFNMX,,READ
         %ENDIF
         GOTO      IOP0CUSA            .
IOP3CUSA
         %IF       C$CPINT <> C$CPSUN  . used for all standard compilers
         OPEN      CUSA,$BLDFNMX,EXCLUSIVE
         %ELSE
         OPEN      CUSA,$BLDFNMX,,EXCLUSIVE
         %ENDIF
         GOTO      IOP0CUSA            .
IOP0CUSA BRANCH    IOFLAG,IOPXCUSA     . was it found ?
         MOVE      ONE,CUS$OPNA        . the CUSA index is now open
IOPXCUSA RETURN                        . exit with 'IOFLAG' set
         %ENDIF                        . closing IO$CUSA
         %ENDIF                        . closing $EDITCUS
+
.  Read routines for index: ' ' -- Primary ISAM index
.  --------------------------------------------------------------------
.
         %IFNZ     IO$CUS
IORKCUS  BRANCH    CUS$OPN,IOX1CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX1CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOK$CUS  READ      CUS,CUS$KEY; CUS$RLST . random access read
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READ      CUS,CUS$KEY;*8:     . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
         %IFZ      $EDITCUS
IOTKCUS  BRANCH    CUS$OPN,IOX2CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX2CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      CUS,WS;;
         RETURN                        .
         %ENDIF
*
         %ENDIF                        . closing IO$CUS
 
IOEKCUS
         %IFZ      $EDITCUS
         UNPACK    CUSNAME,WSD         . get description field contents
         %ENDIF
         TYPE      WSD                 . is this a null description?
         GOTO      IOEKCUS2 IF EOS     . ...yes, make sure it's completely null
         ENDSET    WSD                 . pad with trailing blanks
IOEKCUS2 APPEND    BLANKS,WSD          . ...in case read failed, clearing WSD
         RESET     WSD                 .
         SETLPTR   WSD,35              . adjust size of description text
         RETURN                        .
*
         %IFNZ     IO$CUS
IOKSCUS  BRANCH    CUS$OPN,IOX4CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX4CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOQ$CUS  READKS    CUS; CUS$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   CUS$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READKS    CUS;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
IOKPCUS  BRANCH    CUS$OPN,IOX3CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX3CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOP$CUS  READKP    CUS; CUS$RLST       . key sequential read
         IF OVER                       . no record...
           CLEAR   CUS$SVK             .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READKP    CUS;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
.
IOESCUS
         %IFZ      $EDITCUS
         PACK      $KEYTEMP,FLDTYP,CUS$KEY  . save param values
         CALL      CUS$KEY             . build correctly formatted key
         MOVE      CUS$KEY,WS          . deliver key result in WS
         MOVE      CUS$KEY,CUS$SVK     . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,CUS$KEY  . restore param values
         %ELSE
         SETLPTR   WS,5                . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      CUS,NULL;*8:
                   WSD;
         %ENDIF                        . closing $EDITCUS
         GOTO      IOEKCUS             . complete the description field
*
         %IFZ      $EDITCUS
IOSQCUS  MOVE      SEQ,$RECORD         . set up for physical seq'l read
IORRCUS  BRANCH    CUS$OPN,IOX5CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX5CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READSQ",IOMODE     .  and the I/O procedure
.
         READ      CUS,$RECORD; CUS$RLST . random or seq'l read
         GOTO      IORXCUS             . perform post-read processing
         %ENDIF                        . closing $EDITCUS
*
         %IFZ      $EDITCUS
IOFRCUS  BRANCH    CUS$OPN,IOX6CUS     . is this index now open ?
         CALL      IOPNCUS             . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX6CUS  MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "RPOSIT",IOMODE     .  and the I/O procedure
.
         REPOSIT   CUS,N9              . re-set the file cursor
         RETURN                        .
.
IOFPCUS  FPOSIT    CUS,N9              . get present file cursor
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
 
*
IOGZCUS  IF        (CUS$OPN = 0)       . is this index now open?
           CALL    IOPNCUS             . no... then open it now
           BRANCH  IOFLAG,IOPRCUS      . was index opened OK ?
         ENDIF
         READ      CUS,SEQ3;;          . get total file size
IOGPCUS  FPOSIT    CUS,$FILPOSN        . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$CUS
+
.  Read routines for index: '2' -- Alpha by Customer
.  --------------------------------------------------------------------
.
         %IFNZ     IO$CUS2
IORKCUS2 BRANCH    CUS$OPN2,IOX1CUS2   . is this index now open ?
         CALL      IOPNCUS2            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX1CUS2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOK$CUS2 READ      CUS2,CUS$KEY2; CUS$RLST . random access read
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READ      CUS2,CUS$KEY2;*8:   . get the description field
                   WSD;
         IF OVER                       . justincase... PL/B might be
           CLEAR   WSD                 .   configured not to clear data
         ENDIF                         .   if record not found /JA
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
         %IFZ      $EDITCUS
IOTKCUS2 BRANCH    CUS$OPN2,IOX2CUS2   . is this index now open ?
         CALL      IOPNCUS2            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX2CUS2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM2,FILENAME   . set the disk file name
         MOVE      "READ",IOMODE       .  and the I/O procedure
         READ      CUS2,WS;;
         RETURN                        .
         %ENDIF
*
IOKSCUS2 BRANCH    CUS$OPN2,IOX4CUS2   . is this index now open ?
         CALL      IOPNCUS2            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX4CUS2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM2,FILENAME   . set the disk file name
         MOVE      "READKS",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOQ$CUS2 READKS    CUS2; CUS$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   CUS$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READKS    CUS2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
IOKPCUS2 BRANCH    CUS$OPN2,IOX3CUS2   . is this index now open ?
         CALL      IOPNCUS2            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX3CUS2 MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM2,FILENAME   . set the disk file name
         MOVE      "READKP",IOMODE     .  and the I/O procedure
.
         %IFZ      $EDITCUS
IOP$CUS2 READKP    CUS2; CUS$RLST      . key sequential read
         IF OVER                       . no record...
           CLEAR   CUS$SVK2            .   no longer allow redund. I/O suppress
         ENDIF                         .
         GOTO      IORXCUS             . perform post-read processing
         %ELSE
.
         READKP    CUS2;*3:
                   WS;
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
.
IOESCUS2
         %IFZ      $EDITCUS
         PACK      $KEYTEMP,FLDTYP,CUS$KEY2 . save param values
         CALL      CUS$KEY2            . build correctly formatted key
         MOVE      CUS$KEY2,WS         . deliver key result in WS
         MOVE      CUS$KEY2,CUS$SVK2   . now allow redund. I/O suppress
         UNPACK    $KEYTEMP,FLDTYP,CUS$KEY2 . restore param values
         %ELSE
         SETLPTR   WS,40               . adjust to size of index key
         MOVE      "REREAD",IOMODE     . set to re-read the last record
         READ      CUS2,NULL;*8:
                   WSD;
         %ENDIF                        . closing $EDITCUS
         GOTO      IOEKCUS             . complete the description field
 
*
IOGZCUS2 IF        (CUS$OPN2 = 0)      . is this index now open?
           CALL    IOPNCUS2            . no... then open it now
           BRANCH  IOFLAG,IOPRCUS      . was index opened OK ?
         ENDIF
         READ      CUS2,SEQ3;;         . get total file size
IOGPCUS2 FPOSIT    CUS2,$FILPOSN       . get present file position
         RETURN                        .
.
         %ENDIF                        . closing IO$CUS2
+
.  Read routines for index: 'A' -- General AIM Index
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSA
IORKCUSA BRANCH    CUS$OPNA,IOX1CUSA   . is this index now open ?
         CALL      IOPNCUSA            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX1CUSA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNMA,FILENAME   . set the disk file name
         MOVE      "AMREAD",IOMODE     .  and the I/O procedure
.
IOK$CUSA READ      CUSA,$AIMKLST; CUS$RLST . this is an AIM read
         GOTO      IORXCUS             . perform post-read processing
*
IOKSCUSA BRANCH    CUS$OPNA,IOX4CUSA   . is this index now open ?
         CALL      IOPNCUSA            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX4CUSA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNMA,FILENAME   . set the disk file name
         MOVE      "READKG",IOMODE     .  and the I/O procedure
.
IOQ$CUSA READKG    CUSA; CUS$RLST      . for next generic key
         GOTO      IORXCUS             . perform post-read processing
*
         %IFNZ     C$READGP
IOKPCUSA BRANCH    CUS$OPNA,IOX3CUSA   . is this index now open ?
         CALL      IOPNCUSA            . no... then open it now
         BRANCH    IOFLAG,IOPRCUS      . was index opened OK ?
IOX3CUSA MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNMA,FILENAME   . set the disk file name
         MOVE      "RDKGP ",IOMODE     .  and the I/O procedure
.
IOP$CUSA READKGP   CUSA; CUS$RLST      . read for prior generic key
         GOTO      IORXCUS             . perform post-read processing
         %ENDIF                        . closing C$READGP
*
IOGZCUSA IF        (CUS$OPNA = 0)      . is this index now open?
           CALL    IOPNCUSA            . no... then open it now
           BRANCH  IOFLAG,IOPRCUS      . was index opened OK ?
         ENDIF
         READ      CUSA,SEQ3;;         . get total file size
IOGPCUSA FPOSIT    CUSA,$FILPOSN       . get present file position
         RETURN                        .
         %ENDIF                        . closing IO$CUSA
         %ENDIF                        . closing $EDITCUS
*
.  Post processing to be performed following all full-record reads.
.  --------------------------------------------------------------------
.
         %IFZ      $EDITCUS
IORXCUS  BRANCH    IOFLAG,IOPRCUS      . exit now if I/O problem
         RETURN    IF OVER             . return with 'OVER' set
.
         CALL      IORYCUS             . convert file-format read list to mem.
         MOVE      ZERO,N1             . clear the 'OVER' flag
         RETURN                        . return with 'OVER' clear
.
*
.   Convert file-format read list into memory format
.
IORYCUS
         CALL      VCUSCTR             . deduce active array rows
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
+
.  Write routine for file: CUS -- Customer File
.  ------------------------------------------------------------------
.
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSWT
IOWUCUS
         CALL      IOPNCUSX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         %IFNZ     C$AUDTRL
         CALL      AUDTROPN            . ensure access to audit trail log
         MOVE      "V",  $IOAUDFN      . action is write/update
         %ENDIF
         MOVE      CUSCOLIS,C2         . prepare to increment counter
         CALL      $COUNTER            . for the updated record
         MOVE      C2,CUSCOLIS         .
         GOTO      IOWVCUS8            .
.
IOWTCUS
         CALL      IOPNCUSX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         %IFNZ     C$AUDTRL
         CALL      AUDTROPN            . ensure access to audit trail log
         MOVE      "W",  $IOAUDFN      . action is write
         %ENDIF
         MOVE      $NWCOLIS,CUSCOLIS   . initialize the update counter
.
         CALL      IOLVCUS             . get new LVA value and set FILEPI
         BRANCH    IOFLAG,RETURN       . respond to error during LVA read
         RETURN    IF OVER             . no LVA value could be obtained
         CALL      CUS$KEYX            . build all record keys for WRITE
         GOTO      IOWVCUS9            . proceed to WRITE with FILEPI active
.
.   Write this record with pre-existing record key value(s)
.
IOWVCUS8
         CALL      CUS$KEYX            . build all record keys for WRITE
         IF (CUS$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CUS              .   yes, enqueue the data file
         ENDIF
.>IOZ1CUS
.
IOWVCUS9
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "WRITE",IOMODE      .  and the I/O procedure
         WRITE     CUS$FLST; CUS$WLST  . This is an indexed write to filelist
         BRANCH    IOFLAG,IOWDCUS      . respond to error during write
.
         FILEPI    0                   . release data file enqueue
         %IFNZ     C$AUDTRL
         MOVE      "CUS",C3            . writing to this file code
         PACK      WS$DIS,CUS$MLST     . type of function was set previously
         CALL      AUDTRAIL            . log audit trail
         %ENDIF
.
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful write
*
.  Come here to back the record out of the file if an error occurred
.  -----------------------------------------------------------------
.
IOWDCUS  FILEPI    0                   . release data file enqueue
         %IFNZ     C$AUDTRL
         MOVE      "CUS",C3            . writing to this file code
         PACK      WS$DIS,CUS$MLST     . type of function was set previously
         CALL      AUDTRAIL            . log audit of I/O error case
         %ENDIF
         RETURN                        . exit with record NOT written
         %ENDIF                        . closing IO$CUSWT
*
.   Determine new LVA key value for write or update
.
.   ENTRY:
.      Record contents are filled for write or update
.   EXIT:
.      IOFLAG =1 if error     (the LVA key will be changed, not restored)
.      OVER is ON if no more sequence values are available
.      OVER is OFF and LVA field contains good value if all is OK
.
         %IFNZ     IO$CUSWT,IO$CUSUP   . compile for either update or write
IOLVCUS
         MOVE      CUS$KEY,$KEYTEMP    . save current value of key for update
         MOVE      CUS$LVMX,CUSCUSNO   . begin probe at max key value
         CALL      CUS$KEY             . build the key controlling this LVA
.
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "READLV",IOMODE     .  and the I/O procedure
         IF (CUS$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CUS              .   yes, enqueue the data file
         ENDIF
.>IOZ4CUS
.
.   Determine the new LVA record key
.
         READ      CUS,CUS$KEY;;       . position past last record in series
         BRANCH    IOFLAG, IOLVCUSV
         GOTO      IOLVCUSV IF NOT OVER  ...ERROR: max key is already in file
         READKP    CUS; *3,  CUSCUSNO; . record has the last-used value
         BRANCH    IOFLAG, IOLVCUSV
         GOTO      IOLVCUS6 IF OVER    . no record; start a new sequence
         COMPARE   CUS$LVFR,CUSCUSNO   . if prior value less than LVA range,
         GOTO      IOLVCUS6 IF LESS    .   then start the new sequence
.
         ADD       CUS$LVIN,CUSCUSNO   . continue existing number sequence
         GOTO      IOLVCUSV IF OVER    .   overflow- can't get a new number
         COMPARE   CUSCUSNO,CUS$LVMX   .   if new value would exceed LVA range,
         GOTO      IOLVCUSV IF LESS    .   quit- no good new values available
         MOVE      $KEYTEMP,CUS$KEY    . restore current value of this key
         RETURN                        . OVER is off - LV field value is good
.
IOLVCUS6
         MOVE      $KEYTEMP,CUS$KEY    . restore current value of this key
         MOVE      CUS$LVFR,CUSCUSNO   . start new number sequence
         RETURN                        . OVER is off - LV field value is good
.
IOLVCUSV
         FILEPI    0                   . cannot write or update record
         MOVE      $KEYTEMP,CUS$KEY    . restore current value of this key
         SETFLAG   NOT EOS             . not showing other-user interference
         SETFLAG   OVER                . signal no sequence value available
         RETURN                        . ready to exit from IO module
         %ENDIF                        . closing (IO$CUSWT,IO$CUSUP)
         %ENDIF                        . closing $EDITCUS
 
+
.  Delete routine for file: CUS -- Customer File
.  -------------------------------------------------------------------
.
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSDE
IODLCUS  CALL      IOPNCUSX            . open all indexes
         BRANCH    IOFLAG,RETURN       . is everything opened OK?
         %IFNZ     C$AUDTRL
         CALL      AUDTROPN            . ensure access to audit trail log
         %ENDIF
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "DLREAD",IOMODE     .  and the I/O procedure
.
         IF (CUS$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CUS              .   yes, enqueue the data file
         ENDIF
.>IOZ2CUS
         READ      CUS,CUS$KEY;$RDCOLIS; . read the current record status
         BRANCH    IOFLAG,IODXCUS      . treat I/O error as missing key
         GOTO      IODXCUS IF OVER     . did the record disappear ?
         MATCH     $RDCOLIS,CUSCOLIS   . has it changed ?
         GOTO      IODCCUS IF NOT EQUAL . yes...
         MOVE      ZERO,N1             . no missing keys yet
         MOVE      "DELETE",IOMODE     . remaining I/O will be delete
.
         DELETE    CUS$FLST            . delete record and keys using filelist
         IF OVER
           MOVE    ONE,N1              . record key not found
         ENDIF                         . if I/O trap, just proceed with IOFLAG
         FILEPI    0                   . release data file enqueue
.
         %IFNZ     C$AUDTRL
         MOVE      "CUS",C3            . writing to this file code
         MOVE      "D",  $IOAUDFN      . action is delete
         PACK      WS$DIS,CUS$MLST     . log success or I/O error case
         CALL      AUDTRAIL            . will save N1 = missing-key switch
         %ENDIF                        .   and will save IOFLAG
         BRANCH    N1,IODXCUS          . report the missing key(s)
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit after successful delete
*
.  Come here if at least one key to be deleted was not found
.  ---------------------------------------------------------
.
IODXCUS  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with partial or no delete
*
.  Come here if foreign update was detected during delete request
.  --------------------------------------------------------------
.
IODCCUS  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no delete performed
         %ENDIF                        . closing IO$CUSDE
         %ENDIF                        . closing $EDITCUS
 
+
.  Update routine for file: CUS -- Customer File
.  -------------------------------------------------------------------
.
         %IFZ      $EDITCUS
         %IFNZ     IO$CUSUP
IOUPCUS
         CALL      IOPNCUSX            . open all indexes
         BRANCH    IOFLAG,IOPRCUS      . opened OK ?
.>IOX9CUS
         %IFNZ     C$AUDTRL
         CALL      AUDTROPN            . ensure access to audit trail log
         %ENDIF
.
         IF (CUS$OPNM = 1)             . was file opened shared ?
           FILEPI  99;CUS              .   yes, enqueue the data file
         ENDIF
.>IOZ3CUS
.
         MOVE      CUSCOLIS,C2         . assume update will succeed, and
         CALL      $COUNTER            . increment the counter character
.
         MOVE      CUSCOLIS,C3         . temp save prior counter
         MOVE      C2,CUSCOLIS         . pack/hold the after-update counter
        %IF        C$CPINT = C$CPSUN
         PACKKEY   $IOAUDAI,CUS$MLST   . sv after-updt rec; allow short DIMs
        %ENDIF
        %IF        C$CPINT = C$CPDBC
         PACKLEN   $IOAUDAI,CUS$MLST   . sv after-updt rec; allow short DIMs
        %ENDIF
         MOVE      C3,CUSCOLIS         . retain orig justincase read fails
.
         MOVE      ZERO,IOFLAG         . clear the I/O error flag
         MOVE      CUS$FNM,FILENAME    . set the disk file name
         MOVE      "UPREAD",IOMODE     .  and the I/O procedure
         READ      CUS,CUS$KEY;WS$DIS  . get the record before update
         BRANCH    IOFLAG,IOUXCUS      . treat I/O error as missing key
         GOTO      IOUXCUS IF OVER     . has the record disappeared ?
         MATCH     CUSCOLIS,WS$DIS     . has the counter changed?
         GOTO      IOUCCUS IF NOT EQUAL . yes...
         MOVE      C2,CUSCOLIS         . increment the record counter
         MOVE      "UPDATE",IOMODE     .
         UPDATE    CUS$FLST; CUS$WLST  . update record in place by filelist
         FILEPI    0                   . release data file enqueue
 
         %IFNZ     C$AUDTRL
         UNPACK    WS$DIS,CUS$RLST     . record image has RLST special format
         CALL      IORYCUS             . convert file-format read list to mem.
         PACK      WS$DIS, CUS$MLST    . log MLST format to audit trail
         MOVE      "CUS",C3            . writing to this file code
         MOVE      "B",  $IOAUDFN      . action is before-image of update
         CALL      AUDTRAIL            . record image already in WS$DIS
.
         UNPACK    $IOAUDAI,CUS$MLST   . retrieve saved after-image mem vars
         MOVE      $IOAUDAI,WS$DIS     . log MLST format to audit trail
         MOVE      "CUS",C3            . writing to this file code
         MOVE      "U",  $IOAUDFN      . action is update
         CALL      AUDTRAIL            .
         %ENDIF
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with successful update
*
.  Come here if foreign update was detected during field changes
.  -------------------------------------------------------------
.
IOUCCUS  FILEPI    0                   . release data file enqueue
         MOVE      ZERO,N1             . clear the 'OVER' flag
         CMATCH    SPC,NULL            . set the 'EOS' flag
         RETURN                        . exit with no update performed
*
.  Come here if I/O error, or record disappeared during field changes
.  ------------------------------------------------------------------
.
IOUXCUS  FILEPI    0                   . release data file enqueue
         MOVE      "10",N1             . set the 'OVER' flag
         CMATCH    SPC,BLANKS          . clear the 'EOS' flag
         RETURN                        . exit with error or lost record
         %ENDIF                        . closing IO$CUSUP
*
         %IFNZ     C$AUDTRL
         INCLUDE   AUDTRL/MBR          . standard routine to do audit trail
         %ENDIF
         %ENDIF                        . closing $EDITCUS
+
.  Convert special storage format:  From AIM key memory to file format
.  -------------------------------------------------------------------
.  Entry:
.     C5  = 5-char field name
.     WS2 = AIM search string to be converted
.     $AIMFLDN = aim field number
.     $AIMTYPE = user's selected match type
.  Exit:
.     WS2 = converted result ready to go into $AIMKTRN(j)
.
         %IFZ      $EDITCUS
IOXLCUS
         RETURN
         %ENDIF                        . closing $EDITCUS
+
.  Data handling for Array: ADR -- Two Line Address
.  -------------------------------------------------------------------
.
*
.  Entry points for LOAD & STORES - one complete row of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUSADR
         CALL      LDCUS015            . Address..:
         RETURN                        .
STCUSADR
         CALL      STCUS015            . Address..:
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
.  Entry points for LOAD & STORE - individual field of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUS015 LOAD      CUSADDRS,LINENO:
                   CUS01501,CUS01502
         RETURN                        .
STCUS015 STORE     CUSADDRS,LINENO:
                   CUS01501,CUS01502
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
+
.  Data handling for Array: AUT -- People authorized to place orders
.  -------------------------------------------------------------------
.
*
.  Entry points for LOAD & STORES - one complete row of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUSAUT
         CALL      LDCUS060            . Name
         CALL      LDCUS062            . Job Title
         CALL      LDCUS065            . Phone Number
         RETURN                        .
STCUSAUT
         CALL      STCUS060            . Name
         CALL      STCUS062            . Job Title
         CALL      STCUS065            . Phone Number
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
.  Entry points for LOAD & STORE - individual field of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUS060 LOAD      CUSANAME,LINENO:
                   CUS06001,CUS06002,CUS06003,CUS06004,CUS06005:
                   CUS06006,CUS06007,CUS06008,CUS06009,CUS06010
         RETURN                        .
STCUS060 STORE     CUSANAME,LINENO:
                   CUS06001,CUS06002,CUS06003,CUS06004,CUS06005:
                   CUS06006,CUS06007,CUS06008,CUS06009,CUS06010
         RETURN                        .
LDCUS062 LOAD      CUSTITLE,LINENO:
                   CUS06201,CUS06202,CUS06203,CUS06204,CUS06205:
                   CUS06206,CUS06207,CUS06208,CUS06209,CUS06210
         RETURN                        .
STCUS062 STORE     CUSTITLE,LINENO:
                   CUS06201,CUS06202,CUS06203,CUS06204,CUS06205:
                   CUS06206,CUS06207,CUS06208,CUS06209,CUS06210
         RETURN                        .
LDCUS065 LOAD      CUSAPHON,LINENO:
                   CUS06501,CUS06502,CUS06503,CUS06504,CUS06505:
                   CUS06506,CUS06507,CUS06508,CUS06509,CUS06510
         RETURN                        .
STCUS065 STORE     CUSAPHON,LINENO:
                   CUS06501,CUS06502,CUS06503,CUS06504,CUS06505:
                   CUS06506,CUS06507,CUS06508,CUS06509,CUS06510
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
+
.  Data handling for Array: WHS -- List of Warehouses
.  -------------------------------------------------------------------
.
*
.  Entry points for LOAD & STORES - one complete row of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUSWHS
         CALL      LDCUS070            . Warehouse City
         CALL      LDCUS075            . Warehouse State
         RETURN                        .
STCUSWHS
         CALL      STCUS070            . Warehouse City
         CALL      STCUS075            . Warehouse State
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
*
.  Entry points for LOAD & STORE - individual field of the array
.  --------------------------------------------------------------
.
         %IFZ      $EDITCUS
LDCUS070 LOAD      CUSWHCTY,LINENO:
                   CUS07001,CUS07002,CUS07003,CUS07004,CUS07005:
                   CUS07006,CUS07007,CUS07008,CUS07009,CUS07010:
                   CUS07011,CUS07012,CUS07013,CUS07014,CUS07015:
                   CUS07016,CUS07017,CUS07018,CUS07019,CUS07020
         RETURN                        .
STCUS070 STORE     CUSWHCTY,LINENO:
                   CUS07001,CUS07002,CUS07003,CUS07004,CUS07005:
                   CUS07006,CUS07007,CUS07008,CUS07009,CUS07010:
                   CUS07011,CUS07012,CUS07013,CUS07014,CUS07015:
                   CUS07016,CUS07017,CUS07018,CUS07019,CUS07020
         RETURN                        .
LDCUS075 LOAD      CUSWHSTA,LINENO:
                   CUS07501,CUS07502,CUS07503,CUS07504,CUS07505:
                   CUS07506,CUS07507,CUS07508,CUS07509,CUS07510:
                   CUS07511,CUS07512,CUS07513,CUS07514,CUS07515:
                   CUS07516,CUS07517,CUS07518,CUS07519,CUS07520
         RETURN                        .
STCUS075 STORE     CUSWHSTA,LINENO:
                   CUS07501,CUS07502,CUS07503,CUS07504,CUS07505:
                   CUS07506,CUS07507,CUS07508,CUS07509,CUS07510:
                   CUS07511,CUS07512,CUS07513,CUS07514,CUS07515:
                   CUS07516,CUS07517,CUS07518,CUS07519,CUS07520
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
+
.  Calculation of Rows Active Counters not defined in the data record
.  ------------------------------------------------------------------
.
         %IFZ      $EDITCUS
VCUSCTR  MOVE      LINENO,N3           . save current value of 'LINENO'
.
         MOVE      CUS$ZADR,LINENO     . Two Line Address
         LOOP                          . backward thru all rows, from last
           CALL    LDCUSADR            . fetch this row
           COUNT   N2,CUSADDRS         . Address..:
         WHILE ZERO
           SUB     ONE,LINENO          . check next row in array
         REPEAT WHILE GREATER
         MOVE      LINENO,CUS$$ADR     . set number of active rows
.
         MOVE      N3,LINENO           . restore saved value of 'LINENO'
         RETURN                        .
         %ENDIF                        . closing $EDITCUS
.
.   The following label is referenced by the file maintenance program solely
.   to verify that this .IO module will update isam and aim keys if changed
.   (feature new in version 2.9.1).  When a new F.M.P. tries to include an
.   older .IO module, this label will be undefined and will prevent compilation
.   because that is not supported. Upon seeing this label undefined, the
.   programmer should regenerate the file's .IO module.
.
IOVRCUS_please_Regen  RETURN           . (never really executed)
.
         endif     . closing if (0) - allows including at top of program
         %ENDIF    . closing IO$CUSIO - allow multiple including
.
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
.*               END OF I/O ROUTINE SOURCE CODE - DEMOCUS.IO
.* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 
